//
//  MIDIDriver.h
//  Obie
//
//  Created by groumpf on Sat Apr 03 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreMIDI/MIDIServices.h>

// sound
#define VOICE_TAB_SIZE 608
#define VOICE_SYSEX_SIZE  (VOICE_TAB_SIZE+11)
#define VOICE_PARAMETER_CHANGE_TYPE 0x20
#define VOICE_DUMP_PART1 0x40
#define VOICE_DUMP_PART2 0x41
#define VOICE_DUMP_PART3 0x42
#define VOICE_DUMP_PART4 0x43
#define VOICE_DUMP_INTERNAL 0x51
#define VOICE_COMMON_SIZE 112
#define VOICE_OP_SIZE 62


// multi
#define MULTI_COMMON_SIZE 80
#define MULTI_EFFECTS_SIZE 112
#define MULTI_PART_SIZE 52
#define MULTI_TAB_SIZE (MULTI_COMMON_SIZE+MULTI_EFFECTS_SIZE+MULTI_PART_SIZE*4)
#define MULTI_SYSEX_SIZE (MULTI_TAB_SIZE+11)
#define MULTI_PARAMETER_CHANGE_TYPE 0x10
#define MULTI_DUMP_TYPE 0x10


@interface MIDIDriver : NSObject {
	MIDIClientRef mMIDIclient;
	MIDIPortRef 	mInPort;
	MIDIPortRef		mOutPort;
	MIDIEndpointRef	mDest;
	MIDIEndpointRef mSource;
	int mInputPortNumber;
	int mOutputPortNumber;
}

// singleton
+ (MIDIDriver *)sharedInstance;

- (void)setMIDIInput:(int)aInputPort Output:(int)aOutputPort;
- (NSArray *)midiInputs;
- (NSArray *)midiOutputs;
-(int)inputPortNumber;
-(int)outputPortNumber;

- (void)reset;


// envoi d'un parameter seul
- (void)sendParameter: (int)aParameter Value:(int) aValue type:(int)aParameterChangeType;

// demande de dump du Voice 
// aBank : 0 pour int
//         1..4 pour le voice du part
// aPath : 0..127
- (OSStatus)sendRequestVoice: (int)aBank patch:(int)aPatch;

- (OSStatus)sendRequestMulti;

// envoi le patch dans le buffer d'edition
// aDumpType type de dump sound ou multi
- (void)sendPatch:(uint8_t*)aPatch type:(int)aDumpType;

- (void)storePatch:(uint8_t*)aPatch Bank:(int)aBank Number:(int)aNumber type:(int)aDumpType;

- (void)sendPatch:(uint8_t*)aPatch Number:(int)aNumber dumpType:(int)aDumpType;

//
// recupere les donnees recues apres un appel a sendRequestDataType
- (int)getReceivedBytes:(uint8_t *)aPatch maxSize:(int)aMaxSize;

@end
