/* ParamTextField */

#import <Cocoa/Cocoa.h>

#import "Description.h"
#import "AbstractDocument.h"

@interface ParamTextField : NSTextField
{
	// point d'origine du clic
	NSPoint origine;	
	
	int max;	// max 
	int min;	// min 
	int offset;	// offset pour les valeurs du GUI
	int displayMin; // min affiche
	int displayMax; // max affiche
	NSArray *valueNames;
	
	// masque pour les champs de bits
	int mask;	
	
	int theIntValue;
	int defaultValue;
}

- (int)min;
- (int)max;
- (void)setMax:(int)aMax;
- (void)setMin:(int)aMin;
- (void)setDisplayMax:(int)aMax;
- (void)updateValue:(int)value;
- (void)setIntValueFromDoc:(int)aValue document:(AbstractDocument*)aDoc;
- (void)setUI:(NSDictionary*)aObject description:(Description*)aDescription;

- (int)getDisplayValue:(int)aValue;

@end
